#!/bin/bash
CADDpath="`dirname \"$0\"`"
CADDpath="`( cd \"$CADDpath/..\" && pwd )`"
if [ -z "$VEPpath" ] ; then source ${CADDpath}/bin/config.sh; fi
${CADDpath}/bin/src/annotateVEP.py --all --vep=<( zcat ${1} | ${CADDpath}/bin/src/VCF2vepVCF.py | sort -k1,1 -k2,2n -k3,3 -k4,4 | uniq | ${CADDpath}/bin/src/extract_scored.py -p ${CADDpath}/prescored/whole_genome_SNVs.tsv.gz --found_out=>( gzip -c > ${2}_p2.tmp ) | ${CADDpath}/bin/src/extract_scored.py -p ${CADDpath}/prescored/InDels.tsv.gz --found_out=>( gzip -c > ${2}_p3.tmp ) | perl ${VEPpath} --quiet --cache --offline --dir ${CADDpath}/annotations/vep/ --buffer 1000 --no_stats --species homo_sapiens --db_version=75 --format vcf --regulatory --sift b --polyphen b --per_gene --ccds --domains --numbers --canonical --total_length --output_file >( awk 'BEGIN{ FS="\t"; OFS="\t"; }{ if ($1 ~ /^#/) { if ($1 ~ /^#Up/) { sub("#","",$1); print "#Chrom","Start","End",$0 } else { print } } else { split($2,a,":"); split(a[2],b,"-"); if (length(b) == 2) { print a[1],b[1],b[2],$0 } else { print a[1],b[1],b[1],$0 } }}' ) --force_overwrite ) | ${CADDpath}/bin/src/score_linModel.py --noMap --noSegDup -m ${CADDpath}/bin/src/model/model_coefficients.txt | ${CADDpath}/bin/src/max_line_hierarchy.py | ${CADDpath}/bin/src/appendPHREDscore.py -t ${CADDpath}/bin/src/model/conversion_table_ext.tsv | awk 'BEGIN{ OFS="\t"; FS="\t" }{ if ($0 !~ /^#/) { print $1,$2,$3,$5,$115,$116 } }' | uniq | gzip -c > ${2}_p1.tmp
( echo "## CADD v1.1 (c) University of Washington and Hudson-Alpha Institute for Biotechnology 2013-2014. All rights reserved."; echo -e "#CHROM\tPOS\tREF\tALT\tRawScore\tPHRED"; zcat ${2}_p1.tmp ${2}_p2.tmp ${2}_p3.tmp | sort -k1,1 -k2,2n -k3,3 -k4,4 ) | bgzip -c > ${2}.tmp
rm ${2}_p3.tmp ${2}_p2.tmp ${2}_p1.tmp
mv ${2}.tmp ${2}
